#include <iostream>
#include <vector>

using namespace std;

int main()
{
    const size_t SCREEN_WIDTH = 80;
    const size_t MAX_ASTERISK = SCREEN_WIDTH - 4;

    size_t number_count;
    cerr << "Enter number count:";
    cin >> number_count;
    cerr << "Enter numbers" << "\n";
    vector<double> numbers(number_count);
    for(size_t i = 0; i < number_count; ++i){
        cerr << i + 1 << ":";
        cin >> numbers[i];
    }
    size_t bin_count;
    cerr << "Enter bins count:";
    cin >> bin_count;
    vector<size_t> bins(bin_count);
    double min = numbers[0];
    double max = numbers[0];
    for (double x : numbers) {
        if (x < min) {
            min = x;
        }
        else if (x > max) {
            max = x;
        }
    }
    size_t max_count = 0;
    double bin_size = (max - min) / bin_count;
    for (size_t i = 0; i < number_count; i++) {
        bool found = false;
        for (size_t j = 0; (j < bin_count - 1) && !found; j++) {
            auto lo = min + j * bin_size;
            auto hi = min + (j + 1) * bin_size;
            if ((lo <= numbers[i]) && (numbers[i] < hi)) {
                bins[j]++;
                found = true;

            if(bins[j] > max_count) max_count = bins[j];
            }
        }
        if (!found) {
            bins[bin_count - 1]++;
            if(bins[bin_count - 1] > max_count) max_count = bins[bin_count - 1];
        }
    }
    if(max_count <= MAX_ASTERISK){
        for(size_t count: bins){
            if (count < 100) cout << " ";
            if (count < 10) cout << " ";
            cout << count << "|";
            for(size_t i = 0; i < count; ++i) cout << "*";
            cout << "\n";
            }
    }
    else{
        for(size_t count: bins){
            if (count < 100) cout << " ";
            if (count < 10) cout << " ";
            cout << count << "|";

        size_t height = MAX_ASTERISK * (static_cast<double>(count) / max_count);
        for(size_t i = 0; i < height; ++i) cout << "*";
            cout << "\n";

        }
    }

cout << "\n";
for(size_t i = 0; i < max_count; ++i){
    for(size_t j = 0; j < bin_count; ++j){
        if(bins[j] > i) cout << "*";
        else cout << " ";
    }
    cout << "\n";
}
}
